# Generated by Django 2.0.5 on 2018-06-18 05:17

import django.contrib.postgres.fields.hstore
import django.db.models.deletion
from django.db import migrations, models


class Migration(migrations.Migration):
    def call_command_to_create_integrations_data(apps, schema_editor):
        from django.core.management import call_command

        call_command("create_integrations")

    def delete_integrations_data(apps, schema_editor):
        IntegrationType = apps.get_model("core", "IntegrationType")
        IntegrationCategory = apps.get_model("core", "IntegrationCategory")
        IntegrationType.objects.all().delete()
        IntegrationCategory.objects.all().delete()

    initial = True

    dependencies = [("accounts", "0014_auto_20180529_1036_squashed_0032_auto_20180801_0515")]

    operations = [
        migrations.CreateModel(
            name="IntegrationCategory",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("created_on", models.DateTimeField(auto_now_add=True)),
                ("updated_on", models.DateTimeField(auto_now=True)),
                ("name", models.CharField(max_length=50)),
            ],
            options={"abstract": False},
        ),
        migrations.CreateModel(
            name="IntegrationType",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("created_on", models.DateTimeField(auto_now_add=True)),
                ("updated_on", models.DateTimeField(auto_now=True)),
                ("name", models.CharField(max_length=50)),
                (
                    "authentication_config",
                    django.contrib.postgres.fields.jsonb.JSONField(blank=True, null=True),
                ),
                ("extra_config", django.contrib.postgres.fields.jsonb.JSONField(blank=True, null=True)),
                (
                    "category",
                    models.ForeignKey(
                        default=1,
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="types",
                        to="core.IntegrationCategory",
                    ),
                ),
            ],
            options={"abstract": False},
        ),
        migrations.RunPython(
            call_command_to_create_integrations_data, delete_integrations_data
        ),
        migrations.CreateModel(
            name="ProviderIntegration",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("created_on", models.DateTimeField(auto_now_add=True)),
                ("updated_on", models.DateTimeField(auto_now=True)),
                (
                    "authentication_info",
                    django.contrib.postgres.fields.jsonb.JSONField(blank=True, null=True),
                ),
                ("other_config", django.contrib.postgres.fields.jsonb.JSONField(blank=True, null=True)),
                (
                    "integration_type",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="providers",
                        to="core.IntegrationType",
                    ),
                ),
                (
                    "provider",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="integrations",
                        to="accounts.Provider",
                    ),
                ),
            ],
            options={"abstract": False},
        ),

        migrations.AlterField(
            model_name='integrationtype',
            name='category',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='types',
                                    to='core.IntegrationCategory'),
        )
    ]
